
set surface_id 1
set lines_list [list 1 2 3 4]
set num_divisions [list 20]
set elems [list dkt]
set cop_angles [list 0.125 0.1 0.075]

set check_point {16.07 0.0 19.15 "Disp Z" {"Contour fill" Static Displacements "" Disp_Z} {Last timestep} "" ""}
lassign $check_point x y z desc result result_type value max_error

set script_path [ file dirname [ file normalize [ info script ] ] ]
set f1 [open [file join $script_path "res.1.txt"] w]

puts -nonewline "Coplanarity angle"
foreach elem $elems {
    puts -nonewline $f1 "\t$elem"
}

set err [catch {
	foreach num $num_divisions {
	    
	    foreach angle $cop_angles {
		
		puts -nonewline $f1 "\n$angle"
		gid_groups_conds::setAttributesF {blockdata[@n='General data']/container[@n='Analysis']/value[@n='elems_coplanarity_angle']} [list v $angle]
		
		# Run for all mesh sizes
		foreach elem_type $elems {
		    
		    # Set element type
		    if { $elem_type ne "Quadrilateral" } {
		        GiD_Process Mescape Meshing ElemType Triangle $surface_id
		        gid_groups_conds::setAttributesF {blockdata[@n='General data']/container[@n='Analysis']/value[@n='triang_internal_elem']} [list v $elem_type]                    
		    } else {
		        GiD_Process Mescape Meshing ElemType Quadrilateral $surface_id
		        gid_groups_conds::setAttributesF {blockdata[@n='General data']/container[@n='Analysis']/value[@n='triang_internal_elem']} [list v "dkt"]                    
		    }                    
		    
		    GidUtils::Disable windows
		    GidUtils::DisableGraphics
		    GiD_Process Mescape Meshing Structured Surfaces $surface_id escape $num {*}$lines_list escape 0 Mescape
		    if { [lindex [GiD_Info Mesh] 0] } {
		        GiD_Process Mescape Meshing CancelMesh Yes
		    }
		    GiD_Process Mescape Meshing Generate $num MeshingParametersFrom=Model Mescape
		    set err [catch {GiD_Process Mescape Utilities Calculate} errstring]
		    after 5000
		    while 1 {
		        set modelName [lindex [lindex $::RunProcInfo 0] 0]
		        set uid [lindex [lindex $::RunProcInfo 0] 2]
		        if { $uid == "" } { break }
		        after 1000
		        update
		    }
		    GidUtils::Enable windows
		    GidUtils::EnableGraphics
		    
		    # Postprocess
		    GiD_Process Mescape Postprocess
		    draw_post::set_active_result $result ""
		    lassign [draw_post::give_point_information [list $x $y $z]] mesh_id num_ nodes nodes_coords p1 min_angle results GPdata    
		    draw_post::end_postprocess stop
		    puts -nonewline $f1 \t[format "%.4f" "[expr abs($results)]"]
		    flush $f1
		}
	    }
	}
    } errstring]

if { $err } {
    set ferr [open [file join $script_path "script.err"] w]
    puts $ferr "Script execution error: $errstring"
    close $ferr
}

flush $f1
after idle [close $f1]
